#!/bin/sh
#VER="2.2.5"
VER="2.2.6beta2"
#DURL="http://download.z-push.org/final/2.2"
DURL="http://download.z-push.org/beta/2.2"

echo " ** building Z-Push tgs for Synology on ver. $VER ** "
rm *.tar.gz
rm *.txt
wget $DURL/z-push-$VER.tar.gz
wget $DURL/z-push-$VER.txt
chown root.users z-push-$VER.*
chmod 640 z-push-$VER.*

rm Z-Push-$VER.tgz
rm -R z-push.old
mv z-push z-push.old
tar -zxvf z-push-$VER.tar.gz -C .; done
mv z-push-$VER z-push

# comment out warning on shared_mem
/bin/sed -i -e 's~ZLog::Write(LOGLEVEL_INFO, "InterProcessData::InitSharedMem~//ZLog::Write(LOGLEVEL_INFO, "InterProcessData::InitSharedMem()~' z-push/lib/core/interprocessdata.php
# make mapi work for listfolders.php -l SYSTEM
/bin/sed -i -e "s~/usr/share/php/mapi/~/var/services/web/z-push/backend/zarafa/mapi/~" z-push/backend/zarafa/listfolders.php

# add log and state dir
mkdir z-push/logs
mkdir z-push/state

# copy over files
cp z-push-$VER.txt z-push
cp merge/config* z-push
cp merge/disabled.html z-push
cp merge/htaccess-log z-push/logs/.htaccess
cp merge/htaccess-log z-push/state/.htaccess

# change ownership and acl
chown -R root.http z-push

chmod 750 z-push
chmod 640 z-push/*
chmod 400 z-push/INSTALL
chmod 400 z-push/LICENSE
chmod 400 z-push/*.txt
chmod 640 z-push/logs/.htaccess
chmod 640 z-push/state/.htaccess
# make executable admin and top
chmod 750 z-push/z-push-admin.php
chmod 750 z-push/z-push-top.php

chmod 750 z-push/autodiscover
chmod 750 z-push/backend
chmod 750 z-push/include
chmod 750 z-push/lib
# logs and state need write for http
chmod 770 z-push/logs
chmod 770 z-push/state
chmod 750 z-push/tools

chmod 640 z-push/autodiscover/*
chmod 400 z-push/autodiscover/INSTALL
# backend and libe has only dirs
chmod 750 z-push/backend/*
chmod 640 z-push/include/*
chmod 750 z-push/lib/*
chmod 640 z-push/tools/*
chmod 750 z-push/tools/dev
chmod 640 z-push/tools/dev/*
# fix backend and lib sub-dirs
chmod 640 z-push/backend/combined/*
chmod 640 z-push/backend/imap/*
chmod 640 z-push/backend/maildir/*
chmod 640 z-push/backend/searchldap/*
chmod 640 z-push/backend/vcarddir/*
chmod 640 z-push/backend/zarafa/*
# listfolders has to be executable
chmod 750 z-push/backend/zarafa/listfolders.php
chmod 750 z-push/backend/zarafa/mapi
chmod 640 z-push/backend/zarafa/mapi/*

chmod 640 z-push/lib/core/*
chmod 640 z-push/lib/default/*
chmod 750 z-push/lib/default/diffbackend
chmod 640 z-push/lib/default/diffbackend/*
chmod 640 z-push/lib/exceptions/*
chmod 640 z-push/lib/interface/*
chmod 640 z-push/lib/request/*
chmod 640 z-push/lib/syncobjects/*
# make executable syncresolverecipient.php
chmod 750 z-push/lib/syncobjects/syncresolverecipient.php
chmod 640 z-push/lib/utils/*
chmod 640 z-push/lib/wbxml/*
chmod 640 z-push/lib/webservice/*

# build tgz package
tar cfvz Z-Push-$VER.tgz z-push/
chmod 660 *.tgz
chown root.users *.tgz
echo " ** done ** "
